unit Browse;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, DBCtrls, Mask, Db, Grids, DBGrids, DBTables;

type
  TBrowseDlg = class(TForm)
    DataSource: TDataSource;
    Grid: TDBGrid;
    Label1: TLabel;
    TelBox: TDBEdit;
    Label2: TLabel;
    FaxBox: TDBEdit;
    EmailBox: TDBEdit;
    Label3: TLabel;
    HomePageBox: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    AddressBox: TDBMemo;
    NotesBox: TDBMemo;
    Label6: TLabel;
    OKButton: TBitBtn;
    DeleteButton: TBitBtn;
    InsertButton: TBitBtn;
    Table: TTable;
    UpdateButton: TBitBtn;
    SearchButton: TBitBtn;
    Query: TQuery;
    procedure FormShow(Sender: TObject);
    procedure UpdateButtonClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure SearchButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BrowseDlg: TBrowseDlg;

implementation

uses Search;

{$R *.DFM}

procedure TBrowseDlg.FormShow(Sender: TObject);
begin
  Table.Active := False;
  UpdateButton.Caption := 'Update Mode';
  Table.ReadOnly := True;
  Grid.ReadOnly := True;
  Table.Active := True;
  Table.SetKey;
  Table.First;
  Grid.Options := Grid.Options + [dgRowSelect,dgAlwaysShowSelection] - [dgEditing];
end;

procedure TBrowseDlg.UpdateButtonClick(Sender: TObject);
var
  I: Integer;
begin
  I := Table.RecNo;
  if not Table.ReadOnly then
    try
      Table.Post;
    except on EDataBaseError do
      ;
    end;
  Table.Active := False;
  Table.ReadOnly := not Table.ReadOnly;
  if Table.ReadOnly then
  begin
    UpdateButton.Caption := 'Update Mode';
    Grid.Options := Grid.Options + [dgRowSelect] - [dgEditing];
    Grid.ReadOnly := True;
  end
  else
  begin
    UpdateButton.Caption := 'View Mode';
    Grid.Options := Grid.Options - [dgRowSelect] + [dgEditing];
    Grid.ReadOnly := False;
  end;
  Table.Active := True;
  Table.RecNo := I;
  Grid.SetFocus;
end;

procedure TBrowseDlg.FormHide(Sender: TObject);
begin
  if not Table.ReadOnly then
    try
      Table.Post;
    except on EDataBaseError do
      ;
    end;
  Table.Close;
end;

procedure TBrowseDlg.DeleteButtonClick(Sender: TObject);
var
  I, ID: Integer;
begin
  ID := Table.Fields.FieldByName('ID').AsInteger;
  I := Table.RecNo;
  Table.Active := False;
  Query.SQL.Clear;
  Query.SQL.Add('delete from PhoneBook where id='+IntToStr(ID));
  Query.ExecSQL;
  Table.Active := True;
  Table.RecNo := I;
  Grid.SetFocus;
end;

{
with Table1 do

begin
  SetKey;
  FieldByName('State').AsString := 'CA';
  FieldByName('City').AsString := 'Santa';
  GotoNearest;
end;
}

procedure TBrowseDlg.InsertButtonClick(Sender: TObject);
begin
  if Table.ReadOnly then
    UpdateButton.OnClick(self);
  Table.Append;
  Grid.SetFocus;
  Grid.EditorMode := True;
end;

procedure TBrowseDlg.OKButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TBrowseDlg.SearchButtonClick(Sender: TObject);
begin
  if SearchButton.Caption = 'Search' then
  begin
    if SearchDlg.ShowModal = mrOK then
    begin
      SearchButton.Caption := 'End Search';
      DeleteButton.Enabled := False;
      InsertButton.Enabled := False;
      UpdateButton.Enabled := False;
    end;
  end
  else
  begin
    SearchButton.Caption := 'Search';
    Query.Active := False;
    DataSource.DataSet := Table;
    Table.Active := True;
    DeleteButton.Enabled := True;
    InsertButton.Enabled := True;
    UpdateButton.Enabled := True;
  end;
end;

end.

{
    if UpdateTable.Locate('KeyField', VarToStr(DataSet.Fields[1].OldValue), []) then
      case UpdateKind of
        ukModify:
          begin
            Edit;
            UpdateTable.Fields[1].AsString := VarToStr(DataSet.Fields[1].NewValue);

            Post;
          end;
        ukInsert:
          begin
            Insert;
            UpdateTable.Fields[1].AsString := VarToStr(DataSet.Fields[1].NewValue);
            Post;
          end;
        ukModify: DeleteRecord;
      end;
        UpdateAction := uaApplied;
end;
}
